# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class OrganizationalUnit(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'object',
        'closing_date': 'date',
        'creation': 'ChangeInfo',
        'description': 'str',
        'is_empty': 'bool',
        'last_update': 'ChangeInfo',
        'name': 'str',
        'open': 'bool',
        'opening_date': 'date',
        'res_id': 'str',
        'url': 'str'
    }

    attribute_map = {
        'links': '_links',
        'closing_date': 'closingDate',
        'creation': 'creation',
        'description': 'description',
        'is_empty': 'isEmpty',
        'last_update': 'lastUpdate',
        'name': 'name',
        'open': 'open',
        'opening_date': 'openingDate',
        'res_id': 'resId',
        'url': 'url'
    }

    def __init__(self, links=None, closing_date=None, creation=None, description=None, is_empty=None, last_update=None, name=None, open=None, opening_date=None, res_id=None, url=None, local_vars_configuration=None):  # noqa: E501
        """OrganizationalUnit - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._closing_date = None
        self._creation = None
        self._description = None
        self._is_empty = None
        self._last_update = None
        self._name = None
        self._open = None
        self._opening_date = None
        self._res_id = None
        self._url = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if closing_date is not None:
            self.closing_date = closing_date
        if creation is not None:
            self.creation = creation
        if description is not None:
            self.description = description
        if is_empty is not None:
            self.is_empty = is_empty
        if last_update is not None:
            self.last_update = last_update
        if name is not None:
            self.name = name
        if open is not None:
            self.open = open
        if opening_date is not None:
            self.opening_date = opening_date
        if res_id is not None:
            self.res_id = res_id
        if url is not None:
            self.url = url

    @property
    def links(self):
        """Gets the links of this OrganizationalUnit.  # noqa: E501

        The _links_ list of the _organizational-units_ resource  # noqa: E501

        :return: The links of this OrganizationalUnit.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this OrganizationalUnit.

        The _links_ list of the _organizational-units_ resource  # noqa: E501

        :param links: The links of this OrganizationalUnit.  # noqa: E501
        :type: object
        """

        self._links = links

    @property
    def closing_date(self):
        """Gets the closing_date of this OrganizationalUnit.  # noqa: E501

        The closing date of the organizational unit  # noqa: E501

        :return: The closing_date of this OrganizationalUnit.  # noqa: E501
        :rtype: date
        """
        return self._closing_date

    @closing_date.setter
    def closing_date(self, closing_date):
        """Sets the closing_date of this OrganizationalUnit.

        The closing date of the organizational unit  # noqa: E501

        :param closing_date: The closing_date of this OrganizationalUnit.  # noqa: E501
        :type: date
        """

        self._closing_date = closing_date

    @property
    def creation(self):
        """Gets the creation of this OrganizationalUnit.  # noqa: E501


        :return: The creation of this OrganizationalUnit.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._creation

    @creation.setter
    def creation(self, creation):
        """Sets the creation of this OrganizationalUnit.


        :param creation: The creation of this OrganizationalUnit.  # noqa: E501
        :type: ChangeInfo
        """

        self._creation = creation

    @property
    def description(self):
        """Gets the description of this OrganizationalUnit.  # noqa: E501

        The description of the institution  # noqa: E501

        :return: The description of this OrganizationalUnit.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this OrganizationalUnit.

        The description of the institution  # noqa: E501

        :param description: The description of this OrganizationalUnit.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def is_empty(self):
        """Gets the is_empty of this OrganizationalUnit.  # noqa: E501

        Indicates whether the organizational unit contains any data (depo, sip, aip)  # noqa: E501

        :return: The is_empty of this OrganizationalUnit.  # noqa: E501
        :rtype: bool
        """
        return self._is_empty

    @is_empty.setter
    def is_empty(self, is_empty):
        """Sets the is_empty of this OrganizationalUnit.

        Indicates whether the organizational unit contains any data (depo, sip, aip)  # noqa: E501

        :param is_empty: The is_empty of this OrganizationalUnit.  # noqa: E501
        :type: bool
        """

        self._is_empty = is_empty

    @property
    def last_update(self):
        """Gets the last_update of this OrganizationalUnit.  # noqa: E501


        :return: The last_update of this OrganizationalUnit.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """Sets the last_update of this OrganizationalUnit.


        :param last_update: The last_update of this OrganizationalUnit.  # noqa: E501
        :type: ChangeInfo
        """

        self._last_update = last_update

    @property
    def name(self):
        """Gets the name of this OrganizationalUnit.  # noqa: E501

        The name of the organizational unit  # noqa: E501

        :return: The name of this OrganizationalUnit.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this OrganizationalUnit.

        The name of the organizational unit  # noqa: E501

        :param name: The name of this OrganizationalUnit.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def open(self):
        """Gets the open of this OrganizationalUnit.  # noqa: E501

        Indicates whether the organizational unit is currently open  # noqa: E501

        :return: The open of this OrganizationalUnit.  # noqa: E501
        :rtype: bool
        """
        return self._open

    @open.setter
    def open(self, open):
        """Sets the open of this OrganizationalUnit.

        Indicates whether the organizational unit is currently open  # noqa: E501

        :param open: The open of this OrganizationalUnit.  # noqa: E501
        :type: bool
        """

        self._open = open

    @property
    def opening_date(self):
        """Gets the opening_date of this OrganizationalUnit.  # noqa: E501

        The opening date of the organizational unit  # noqa: E501

        :return: The opening_date of this OrganizationalUnit.  # noqa: E501
        :rtype: date
        """
        return self._opening_date

    @opening_date.setter
    def opening_date(self, opening_date):
        """Sets the opening_date of this OrganizationalUnit.

        The opening date of the organizational unit  # noqa: E501

        :param opening_date: The opening_date of this OrganizationalUnit.  # noqa: E501
        :type: date
        """

        self._opening_date = opening_date

    @property
    def res_id(self):
        """Gets the res_id of this OrganizationalUnit.  # noqa: E501

        The _organizational-units_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :return: The res_id of this OrganizationalUnit.  # noqa: E501
        :rtype: str
        """
        return self._res_id

    @res_id.setter
    def res_id(self, res_id):
        """Sets the res_id of this OrganizationalUnit.

        The _organizational-units_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :param res_id: The res_id of this OrganizationalUnit.  # noqa: E501
        :type: str
        """

        self._res_id = res_id

    @property
    def url(self):
        """Gets the url of this OrganizationalUnit.  # noqa: E501

        The URL of the organizational unit  # noqa: E501

        :return: The url of this OrganizationalUnit.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this OrganizationalUnit.

        The URL of the organizational unit  # noqa: E501

        :param url: The url of this OrganizationalUnit.  # noqa: E501
        :type: str
        """

        self._url = url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrganizationalUnit):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OrganizationalUnit):
            return True

        return self.to_dict() != other.to_dict()
